<?php
/**
 * Image way2enjoy php class
 *
 * @copyright Copyright (C) 2018 way2enjoy (https://way2enjoy.com). All rights reserved.
 * @license Dual-licensed under the GNU General Public License and the MIT License
 */

// no direct access
defined('_JEXEC') or die;

class ioaphp
{
    /**
     * Authentication values array
     * @var array
     */
    protected $auth = array();

    /**
     * Image Optimize API Url
     * @var string api url
     */
protected $apiUrl = 'https://way2enjoy.com/modules/compress-png/apijoomlaimgcompressor3.php/';
    /**
     * Last Error message
     * @var string
     */
    protected $lastError = null;


    /**
     *
     * @param string $key
     * @param string $secret
     */
    public function __construct($key, $secret)
    {
        $this->auth = array('key' => $key, 'secret' => $secret);
    }

    /**
     * Change the API URL
     * @param string $url
     */
    public function setAPIUrl($url)
    {
        $this->apiUrl = $url;
    }

    /**
     * Upload a file sent through an html post form
     * @param $_FILES $file posted file
     */
    public function uploadFile($file, $params = array())
    {
        if (class_exists('CURLFile')) {
            $curlFile = new CURLFile($file);
        } else {
            $curlFile = '@' . $file;
        }

        $params = array(
            'auth' => json_encode($this->auth),
            'file' => $curlFile,
            'params' => json_encode($params)
        );

        try {
            $result = $this->callAPI($this->apiUrl . 'images/', 'POST', $params);
			

        } catch (Exception $exc) {
            $this->lastError = $exc->getMessage();
            $this->lastErrCode = $exc->getCode();
            return $this->lastError;// false;
        }


        return $result;
		
	//	var_dump($result);
    }

    /**
     * Upload a file from an url
     * @param string $url
     * @return Object
     */
    public function uploadUrl($url, $params = array())
    {
				
        $params = array(
            'auth' => json_encode($this->auth),
            'params' => json_encode(array(
                'params' => $params,
                'url' => $url
            ))
        );
		
			
        try {
            $result = $this->callAPI($this->apiUrl . 'images/', 'POST', $params);
        } catch (Exception $exc) {
            $this->lastError = $exc->getMessage();
            return false;
        }
		
			// test data start shere 
	//	var_dump($params);
		$gfgfgfgfffrrrrtr=print_r($result,true);
		$pathhhhh6699577='/home/payads/public_html/joomla/administrator/components/com_imageway2enjoy/classes/joooo226.txt';
		file_put_contents($pathhhhh6699577,$gfgfgfgfffrrrrtr);
	// test data ends here 
			//	var_dump($result);
		
        return $result;
		
		
	

    }

    /**
     * Call the API with curl
     * @param string $url
     * @param string $type HTTP method
     * @param array $datas
     * @return type
     */
    protected function callAPI($url, $type, $datas)
    {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_HEADER, 0);
        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 100);
        curl_setopt($curl, CURLOPT_TIMEOUT, 1000);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $type);
      
// only for testing purpose
//curl_setopt($curl, CURLINFO_HEADER_OUT, true);
// only for testing purpose ends here
	  
	  
        //fix windows localhost ssl problem
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

        if ($type === 'POST') {
            curl_setopt($curl, CURLOPT_POSTFIELDS, $datas);
        } else {
            $url .= '?' . http_build_query($datas);
        }

			
		
		
        curl_setopt($curl, CURLOPT_URL, $url);
        $content = curl_exec($curl);
		
		
		// if($content) 
		// {
		// $dastatposted = $datas	;
		// }

	//	$dastatposted = curl_getinfo($curl);


        $infos = curl_getinfo($curl);
        $infos['http_code'] = (String)$infos['http_code'];

        if ($infos['http_code'][0] !== '2') {
            $error = json_decode($content);
            if (isset($error->errCode)) {
                $errCode = $error->errCode;
            } else {
                $errCode = 0;
            }
            if (isset($error->errMessage)) {
                $errMessage = $error->errMessage;
            } else {
                $errMessage = 'An error occurs';
            }
            throw new Exception($errMessage, $errCode);
        }
        curl_close($curl);
		
			//	var_dump($content);
// test data start shere 
		//var_dump($params);
		$jjjddfs= print_r($url,true);
		$pathhhhh='/home/payads/public_html/joomla/administrator/components/com_imageway2enjoy/classes/joooo99.txt';
		file_put_contents($pathhhhh,$jjjddfs);
	// test data ends here 
		
        return json_decode($content);
		
		
    }

    /**
     * Get all the images
     * @return type
     */
    public function getImagesList($offset = 0, $limit = 30)
    {
        $params = array(
            'auth' => json_encode($this->auth),
            'params' => '',
            'offset' => $offset,
            'limit' => $limit
        );

	// test data start shere 
	//var_dump($params);
	$jjjdjfd=print_r($params,true);
		$pathhhhh='/home/payads/public_html/joomla/administrator/components/com_imageway2enjoy/classes/joooo991.txt';
		file_put_contents($pathhhhh,$jjjdjfd);
	// test data ends here 
		
		
        try {
            $result = $this->callAPI($this->apiUrl . 'images/', 'GET', $params);
        } catch (Exception $exc) {
            $this->lastError = $exc->getMessage();
            return false;
        }
		
	return $result;
    }

    /**
     * Get one image
     * @param int $id
     * @return type
     */
    public function getImage($id)
    {
        $params = array(
            'auth' => json_encode($this->auth),
            'params' => ''
        );

		
		
        try {
            $result = $this->callAPI($this->apiUrl . 'images/' . (int)$id, 'GET', $params);
		//	$sjsjdsjdjd= $this->apiUrl . 'images/' . (int)$id;

			//    [origin_url] => https://api.imageway2enjoy.com/v1/images/original/1101dfe294ab569cf0921010aa35b8dc/shop-ad.jpg

			
			
        } catch (Exception $exc) {
            $this->lastError = $exc->getMessage();
            return false;
        }
		
        return $result;
    }

    /**
     * Delete an image
     * @param int $id
     * @return type
     */
    public function deleteImage($id)
    {
        $params = array(
            'auth' => json_encode($this->auth),
            'params' => ''
        );

        try {
            $result = $this->callAPI($this->apiUrl . 'images/' . (int)$id, 'DELETE', $params);
        } catch (Exception $exc) {
            $this->lastError = $exc->getMessage();
            return false;
        }
        return $result;
    }

    /**
     * Get account information
     * @return type
     */
    public function getAccountInfos()
    {
        $params = array(
            'auth' => json_encode($this->auth),
            'params' => ''
        );

        try {
            $result = $this->callAPI($this->apiUrl . 'accounts/mine', 'GET', $params);
		
			
        } catch (Exception $exc) {
            $this->lastError = $exc->getMessage();
            return false;
        }
        return $result;
    }

    /**
     * Get last error message
     * @return string
     */
    public function getLastError()
    {
        return $this->lastError;
    }

    public function getLastErrCode()
    {
        return $this->lastErrCode;
    }
}

?>
